local mod = ...



-- Job: Event Trigger -------------------------------------------------------------------------------------
mod:register({
    DataType = "JOB",
    Id = "JOB_ALADDIN_UNLOCK",
    JobName = "JOB_ALADDIN_UNLOCK_NAME",
    JobDescription = "JOB_ALADDIN_UNLOCK_DESC",
    IsLockedByDefault = true,
    Hidden = true,
    DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 0.0, -- default 30
    AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
    CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        IdleAnimation = "IDLE"
    }
})

mod:override({ Id = "NEWCOMER", CompatibleJobList = { Action = "APPEND", "JOB_ALADDIN_UNLOCK" } })
mod:override({ Id = "SERF", CompatibleJobList = { Action = "APPEND", "JOB_ALADDIN_UNLOCK" } })
mod:override({ Id = "COMMONER", CompatibleJobList = { Action = "APPEND", "JOB_ALADDIN_UNLOCK" } })
mod:override({ Id = "CITIZEN", CompatibleJobList = { Action = "APPEND", "JOB_ALADDIN_UNLOCK" } })



-- Quest ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "QUEST",
    Id = "QUEST_ALADDIN_UNLOCK",
    Name = "QUEST_ALADDIN_UNLOCK_NAME",
    Description = "QUEST_ALADDIN_UNLOCK_DESC",
    IsSilent = true,
    QuestFunction = {
        DataType = "QUEST_FUNCTION_ASSIGN_WORKER",
        Job = "JOB_ALADDIN_UNLOCK",
    },
    QuestRewardList = {
        {
            DataType = "QUEST_REWARD_INFLUENCE",
            EstateInfluence = {
                Estate = "CLERGY",
                Quantity = 100,
            },
        },
        {
            DataType = "QUEST_REWARD_INFLUENCE",
            EstateInfluence = {
                Estate = "KINGDOM",
                Quantity = 100,
            },
        },
        {
            DataType = "QUEST_REWARD_INFLUENCE",
            EstateInfluence = {
                Estate = "LABOUR",
                Quantity = 100,
            },
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_CLERGY_BUILDER_WORKSHOP_STAINED_GLASS_WORKSHOP",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_CLERGY_MONASTERY_APIARY",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_CLERGY_MONASTERY_HERB_GARDEN",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_CLERGY_MONASTERY_WINE_PRODUCTION",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_CLERGY_RUSTIC_CHURCH_ADDITIONAL_PARTS",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_KINGDOM_WOODEN_KEEP_DECORATIVE",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_LABOUR_BUILDER_WORKSHOP_SCULPTURE_WORKSHOP",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_LABOUR_LORD_MANOR_STONE_SET",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_LABOUR_MARKET_GOODS_STALL",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_LABOUR_MARKET_LUXURY_STALL",
        },
        {
            DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
            UnlockName = "UNLOCKABLE_LABOUR_TAVERN_STONE_SET",
        },
    },
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil,
    OnSuccessCallback = nil,
})


-- Default Balancing (event list) ---------------------------------------------------------------------------------------------
mod:override({
    Id = "DEFAULT_BALANCING",
    EventList = {
        Action = "APPEND", 
        "EVENT_ALADDIN_UNLOCK_SETUP",
    },
})


-- Event: Setup ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "EVENT",
    Id = "EVENT_ALADDIN_UNLOCK_SETUP",
    Title = "EVENT_ALADDIN_UNLOCK_NAME",
    Description = "EVENT_ALADDIN_UNLOCK_DESC",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysToFirst = 1, -- number of days from the start of the game (setting = 5 will fire the event at the start of Day 5). 
    ConditionList = {
        {
            DataType = "EVENT_CONDITION_BUILDING_BUILT",
            AssetBuilding = "BUILDING_VILLAGE_CENTER"
        }
    },
    ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_ALADDIN_UNLOCK"
        },
    }
})

